-- DizzyDiff Search Tool version 1.4.5 by Tritonio
-- Copyright 2007 Konstantinos Asimakis
-- http://inshame.blogspot.com
-- This program is licensed under the GNU/GPL version 3 and is distributed without
-- any warranty. Make sure you have read the 'LICENSE.txt' file. You can find a
-- copy of the license here: http://www.gnu.org/licenses/

---[[Protected Call
--vvvvvvvvvvvvvvvvv
result,ErrMes=pcall(function ()
--^^^^^^^^^^^^^^^]]

function round(x)
	return math.floor(0.5+x)
end

function AbsMin(a,b)
	if math.abs(a)<math.abs(b) then return a else return b end
end

function DizzyDiffCore(big,small)
	local score=0
	for CurBig=1,string.len(big) do
		local CurBigInSmall=(CurBig-1)/(string.len(big)-1)*(string.len(small)-1)+1
		local MaxDist=math.max(string.len(small)-CurBigInSmall,CurBigInSmall-1)+1 --+1 is for the cases when the character doesn't exist.
		local min=MaxDist
		for CurSmall=1,string.len(small) do
			if string.sub(big,CurBig,CurBig)==string.sub(small,CurSmall,CurSmall) then min=math.min(min,math.abs(CurBigInSmall-CurSmall)) end
		end
		score=score+((MaxDist-min)/MaxDist)
	end
	return (score/string.len(big))
end

--[[
function DizzyDiffCore(big,small)
	local score=0
	local average=0
	local TotForAverage=0
	local min={}
	local MaxDist={}
	for CurBig=1,string.len(big) do
		local CurBigInSmall=(CurBig-1)/(string.len(big)-1)*(string.len(small)-1)
		MaxDist[CurBig]=math.max(string.len(small)-CurBigInSmall,CurBigInSmall-1)
		min[CurBig]=math.huge
		for CurSmall=1,string.len(small) do
			if string.sub(big,CurBig,CurBig)==string.sub(small,CurSmall,CurSmall) then
				min[CurBig]=AbsMin(min[CurBig],(CurBigInSmall-CurSmall))
			end
		end
		if min[CurBig]~=math.huge then
			average=average+min[CurBig]
			TotForAverage=TotForAverage+1
		end
	end
	average=average/TotForAverage
	--print(average)
	for CurBig=1,string.len(big) do
		if min[CurBig]~=math.huge then
			score=score+((MaxDist[CurBig]-math.abs(min[CurBig]-average*1))/MaxDist[CurBig])
		end
	end
	
	return score/string.len(big)
end
--]]

function DizzyDiff(big,small)
	big,small=string.upper(big),string.upper(small)
	local score,score2=-1,-1
	if string.len(small)>1 then score=DizzyDiffCore(small,big) end
	if string.len(big)>1 then score2=DizzyDiffCore(big,small) end
	if score>=0 and score2>=0 then score=math.min(score,score2)
	elseif score==-1 and score2==-1 then if big==small then score=1 else score=0 end
	else score=math.max(score,score2) end
	return score*100
end

function UseDamerauLevenshtein()
	function DizzyDiff(s,t)
		local m=string.len(s)+1
		local n=string.len(t)+1
		local d={} for i=0,m do d[i]={} end
		for i=0,m do d[i][0]=i end
		for j=1,n do d[0][j]=j end
		for i=1,m do
			for j=1,n do
				if string.upper(string.sub(s,i-1,i-1))==string.upper(string.sub(t,j-1,j-1)) then cost=0 else cost=1 end
				d[i][j]=math.min(
					         d[i-1][j] + 1,     -- deletion
					         d[i][j-1] + 1,     -- insertion
					         d[i-1][j-1] + cost   -- substitution
					        )
				if i > 1 and j > 1 and string.upper(string.sub(s,i,i)) == string.upper(string.sub(t,j-1,j-1)) and string.upper(string.sub(s,i-1,i-1)) == string.upper(string.sub(t,j,j)) then
					d[i][j] = math.min(
							   d[i][j],
							   d[i-2][j-2] + cost   -- transposition
							  )
				end
	 		end
		end
		return 100-d[m][n]/(math.max(string.len(s),string.len(t)))*100
	end
end

function AllSubCombs(big,small)
	local best=DizzyDiff(big,small)
	local beststring=big
	local TotWordsInString=0
	local words={}
	for w in string.gmatch(big,"['%w]+") do
		TotWordsInString=TotWordsInString+1
		words[TotWordsInString]=w
	end
	if TotWordsInSearch<=TotWordsInString then
		for i=TotWordsInSearch,TotWordsInString do
			if (i-TotWordsInSearch+1)%1000==0 then
				io.write("\008")
				if (i-TotWordsInSearch+1)%4000==0 then io.write("v")
				elseif (i-TotWordsInSearch+1)%4000==1000 then io.write("<")
				elseif (i-TotWordsInSearch+1)%4000==2000 then io.write("^")
				elseif (i-TotWordsInSearch+1)%4000==3000 then io.write(">")
				end
				io.flush()
			end
			local substring=table.concat(words," ",i-TotWordsInSearch+1,i)
			local temp=DizzyDiff(substring,small)
			if temp>best then best=temp beststring=substring end
		end
	end
	
	return best,beststring
end

function FindMin(table)
	local min=table[1][2]
	local whereIsIt=1
        for i=2,TotResults do if min>table[i][2] then min=table[i][2] whereIsIt=i end end
	return min,whereIsIt
end

function FindInReverse(str,pat) --Returns the position of the last match of pat in str.
	local temp=string.find(string.reverse(str),pat,1,true)
	if temp then return string.len(str)-temp+1 end
end

function CheckFileName()
	if WINDOWS then
		file=string.sub(line,FindInReverse(line,"\\")+1,-1) --windows
	else
		file=string.sub(line,FindInReverse(line,"/")+1,-1) --linux
	end
	if FindInReverse(file,".") then
		ext=string.upper(string.sub(file,FindInReverse(file,".")+1,-1))
		file=string.sub(file,1,FindInReverse(file,".")-1)
	else
		ext=""
	end
	score,way=AllSubCombs(file,SearchFor)
end

function CheckTextFile()
	for i,v in ipairs(textensions) do
		if v==ext then
			io.write("TXT")
			io.flush()
			local txthandle=io.open(line,"r")
                        if txthandle then
				local text=txthandle:read(10*1024*1024)
				local txtscore,txtway
				if text then
					io.write(" ")
					txtscore,txtway=AllSubCombs(text,SearchFor)
					io.write("\008")
				else
					txtscore,txtway=-1,""
				end
				txtway=txtway.." (inside file)"
				if txtscore>score then
			                score=txtscore
					way=txtway
				end
				txthandle:close()
			end
			io.write("\008\008\008   \008\008\008")
			io.flush()
			break
		end
	end
end

function CheckTags()
	if "MP3"==ext then
		io.write("ID3")
		io.flush()
		local MP3Handle=io.open(line,"r")
                if MP3Handle then
                	MP3Handle:seek("end",-128)
                	if MP3Handle:read(3)=="TAG" then
				local tag={track=MP3Handle:read(30),
					   artist=MP3Handle:read(30),
					   album=MP3Handle:read(30)}
				io.write(" ")
				local MP3Score,MP3Way=AllSubCombs(tag.track,SearchFor)
				io.write("\008")
				io.write(" ")
				local TempMP3Score,TempMP3Way=AllSubCombs(tag.artist,SearchFor)
				io.write("\008")
				if TempMP3Score>MP3Score then MP3Score=TempMP3Score MP3Way=TempMP3Way end
				io.write(" ")
				local TempMP3Score,TempMP3Way=AllSubCombs(tag.album,SearchFor)
				io.write("\008")
				if TempMP3Score>MP3Score then MP3Score=TempMP3Score MP3Way=TempMP3Way end
				MP3Way=MP3Way.." (inside ID3v1 tags)"
				if MP3Score>score then
				        score=MP3Score
						way=MP3Way
				end
			end
			MP3Handle:close()
		end
		io.write("\008\008\008   \008\008\008")
		io.flush()
	end
end

function ShowHelpAndExit()
	print([[
Command line options:

--help , -h	shows this help text.

--NoVersion	will hide the version and copyright notice.

--os    	followed by WINDOWS or LINUX to override the automatic OS
		detection.

--path , -p	followed by the search path.

--query , -q	followed by the search query. If this is the last parameter you
		may just write the search path. Like this:
				lua5.1 DizzyDiff.lua --os WINDOWS c:\

--raw     	DizzyDiff will not print anything except the search results in
		raw form so that you can parse them with another program.

--debug		DizzyDiff will enter debugging mode after parsing the rest of the
		parameters. You can se this to test the DizzyDiffCore function
		which does the comparisons.

--textension	followed by a file extension (do not include the dot) will add
		this extension to the text extensions list.

--totres	followed by a number to change the number of the results. The
		default is 500.

--totresshown	followed by a number to change the number of results shown per
		screen. The default is 4.

--type , -t	followed by the number of the search type:
                1. Only in filenames
                2. In filenames and ID3 tags (for MP3 files)
                3. In filenames and inside text files
                4. Filenames, Id3 tags and inside text files
                
--udl		DizzyDiff will use the Damerau-Levenshtein distance algorithm
		instead of my own algorithm. I like mine more but you might
		want to try both of them.

--version , -v	show the version and copyright notice and exit immediately.	
]])
	os.exit()
end

function AutomaticOSDetection()
	return (pcall(function () htemp=io.open("c:\\windows\\explorer.exe") htemp:close() end) or pcall(function () htemp=io.open("d:\\windows\explorer.exe") htemp:close() end) or pcall(function () htemp=io.open("e:\\windows\\explorer.exe") htemp:close() end))
end

function ParseCommandLineParameters()
	local moveup=0
	local found=false
	local i=1
	while i<=#arg do
		if string.lower(arg[i])=="--os" then
			WINDOWS=string.upper(arg[i+1])=="WINDOWS"
			moveup=1
			found=true
		end
		if string.lower(arg[i])=="--totres" then
			TotResults=arg[i+1]*1
			moveup=1
			found=true
		end
		if string.lower(arg[i])=="--totresshown" then
			TotResultsShown=arg[i+1]*1
			moveup=1
			found=true
		end
		if string.lower(arg[i])=="-h" or string.lower(arg[i])=="--help" then
			ShowHelpAndExit()
			found=true
		end
		if string.lower(arg[i])=="-v" or string.lower(arg[i])=="--version" then
			ExitAfterVersion=true
			found=true
		end
		if string.lower(arg[i])=="--NoVersion" then
			NoVersion=true
			found=true
		end
		if string.lower(arg[i])=="-q" or string.lower(arg[i])=="--query" then
			SearchFor=arg[i+1]
			moveup=1
			found=true
		end
		if string.lower(arg[i])=="-p" or string.lower(arg[i])=="--path" then
			where=arg[i+1]
			moveup=1
			found=true
		end
		if string.lower(arg[i])=="-t" or string.lower(arg[i])=="--type" then
			SearchType=arg[i+1]
			moveup=1
			found=true
		end
		if string.lower(arg[i])=="--debug" then
			EnterDebugMode=true
			found=true
		end
		if string.lower(arg[i])=="--raw" then
			raw=true
			--backing up the functions while disabling them.
			print,backup1=function () end,print
			io.write,backup2=function () end,io.write
			io.flush,backup3=function () end,io.flush
			found=true
		end
		if string.lower(arg[i])=="--udl" then
			UseDamerauLevenshtein()
			found=true
		end
		if string.lower(arg[i])=="--textension" then
			table.insert(textensions,string.upper(arg[i+1]))
			moveup=1
			found=true
		end
		if i==#arg and string.sub(arg[i],1,1)~="-" then
			where=arg[i]
			found=true
		end
		i=i+moveup+1
		moveup=0
		if not found then error("Unknown command line parameter: "..arg[i]) end
	end
end

function InitializeVariables()
	WINDOWS=AutomaticOSDetection()
	TotResults=500
	TotResultsShown=4
	textensions={"TXT","INI","INF","LOG","BAT","SH","LUA","C","H","CPP"}
end

function ShowVersion()
	print([[
DizzyDiff Search Tool version 1.4.5 by Tritonio
Copyright 2007 Konstantinos Asimakis
http://inshame.blogspot.com
This program is licensed under the GNU/GPL version 3 and is distributed without
any warranty. Make sure you have read the 'LICENSE.txt' file. You can find a
copy of the license here: http://www.gnu.org/licenses/
]])
end

------------------------------------
--  END OF FUNCTION DEFINITIONS   --
------------------------------------

CurState="INITIALIZING VARIABLES"
InitializeVariables()

CurState="PARSING COMMAND LINE OPTIONS"
ParseCommandLineParameters()

if EnterDebugMode then
	print('Type "cont" and press enter to continue executing the rest of the program.')
	while true do
		pcall(function () print(DizzyDiff(io.read(),io.read())) end)
	end
	debug.debug()
end

CurState="SHOWING VERSION INFORMATION"
if not NoVersion then ShowVersion() end
if ExitAfterVersion then os.exit() end

CurState="ASKING THE USER ABOUT THE SEARCH PARAMETERS"
if not SearchFor then
	repeat
		io.write("What are you looking for? Type your query: ")
		SearchFor=io.read()
	until SearchFor~=""
end
if not where then
	if WINDOWS then example="C:\\WINDOWS\\" else example="/media/STORAGE/" end
	io.write("\nWhere should I start searching for it? (eg: "..example..") Type the path or drag and drop a folder on this window: ")
	where=io.read()
end
if not SearchType then
	print("\nSearch type:")
	print("1. Only in filenames")
	print("2. In filenames and ID3 tags (for MP3 files)")
	print("3. In filenames and inside text files")
	print("4. Filenames, ID3 tags and inside text files")
	io.write("Type a number (or leave empty to use the 1st type) and press enter: ")
	SearchType=io.read()
end

CurState="PREPARING SEARCH"
LookInsideText=SearchType=="3" or SearchType=="4"
InsideID3=SearchType=="2" or SearchType=="4"
TotWordsInSearch=0
for w in string.gmatch(SearchFor,"['%w]+") do
	TotWordsInSearch=TotWordsInSearch+1
end
where=string.gsub(where,"^%s*(.-)%s*$","%1")
if string.sub(where,1,1)=="'" then where=string.sub(where,2,-1) end
if string.sub(where,1,1)=='"' then where=string.sub(where,2,-1) end
if string.sub(where,-1,-1)=="'" then where=string.sub(where,1,-2) end
if string.sub(where,-1,-1)=='"' then where=string.sub(where,1,-2) end
if WINDOWS then
	if string.sub(where,-1)~="\\" then where=where.."\\" end
else
	if string.sub(where,-1)~="/" then where=where.."/" end
end


CurState="SEARCHING"

print()
io.write("Please wait...  ")
io.flush()

if WINDOWS then
	handle=io.popen('dir "'..where..'*.*" /s /b',"r") --windows
else
	handle=io.popen("find '"..where.."'","r") --linux
end

top={} --This is the table that will hold the results.
for i=1,TotResults do top[i]={"",-1,""} end

TotFiles=0
while true do
    line=handle:read()
	if line==nil then break end
	if TotFiles%250==0 then
		io.write("\008")
		if TotFiles%10000==0 and TotFiles~=0 then io.write("|") end
		if TotFiles%1000==0 then io.write("|")
		elseif TotFiles%1000==250 then io.write("/")
		elseif TotFiles%1000==500 then io.write("-")
		elseif TotFiles%1000==750 then io.write("\\")
		end
		io.flush()
	end
	TotFiles=TotFiles+1

	CheckFileName()
	if LookInsideText and score~=100 then CheckTextFile() end
	if InsideID3 and score~=100 then CheckTags() end
	
	local min,whereIsIt=FindMin(top)
	if score>min then top[whereIsIt]={line,score,way} end
end

if TotFiles==0 then
	print("Cannot find any files! Maybe you the directory you gave me doesn't exist. Press enter to quit...") io.read()
else
	table.sort(top,function (x,y) if x[2]>y[2] then return true elseif x[2]<y[2] then return false else return x[1]<y[1] end end)
	print()
	print("Finished searching in "..TotFiles.." files.")
end

CurState="SHOWING THE RESULTS"

TotResults=math.min(TotResults,TotFiles)

if not raw then
	local window=0
	while TotFiles~=0 do
		for i=1+window,TotResultsShown+window do
			if top[i][2]>=0 then
				print()
				print(i..". "..round(top[i][2]*10)/10 .."% match with: "..top[i][3])
				print(top[i][1])
			end
		end
		print()
		if window==0 and window+TotResultsShown==TotResults then
			io.write("To open a result in a window type it's number and press enter. Type q and press enter to quit... ")
		elseif window==0 then
			io.write("To open a result in a window type it's number and press enter. To view more results leave empty and press enter. Type q and press enter to exit... ")
		elseif window+TotResultsShown==TotResults then
			io.write("To open a result in a window type it's number and press enter. To view the previous results type p and press enter. Type q and press enter to quit... ")
		else
			io.write("To open a result in a window type it's number and press enter. To view more results leave empty and press enter. To view the previous results type p and press enter. Type q and press enter to quit... ")
		end
		local number=io.read()
		print()
		if number~="" and tonumber(number) then
			if number*1<=TotResults and number*1>=1 and number*1==math.floor(number) then
				print("Opening "..string.sub(top[number*1][1],1,FindInReverse(top[number*1][1],"/")).."...")
				if WINDOWS then
					os.execute('explorer.exe /select,"'..top[number*1][1]..'"') --windows
				else
					os.execute("nautilus '"..string.sub(top[number*1][1],1,FindInReverse(top[number*1][1],"/")).."'") --linux
				end
			end
		elseif string.upper(number)=="E" or string.upper(number)=="Q" then
			break
		elseif string.upper(number)=="P" then
			if window-TotResultsShown>=0 then
				window=window-TotResultsShown
			end
		elseif number=="" then
			if window+TotResultsShown+TotResultsShown<=TotResults then
				window=window+TotResultsShown
			end
		end
	end
else
	--restore the functions
	print=backup1
	io.write=backup2
	io.flush=backup3
	for i=1,TotResults do
		if top[i][2]>=0 then
			print(round(top[i][2]*10)/10,top[i][1])
		end
	end
end

---[[End of Protected Call
--vvvvvvvvvvvvvvvvvvvvvvvv
end)
if not result then print("\nERROR WHILE "..CurState..".\nDetailed Error Information: "..string.sub(ErrMes,string.find(ErrMes,":")+1,-1).."\n Press enter to exit...") io.read() end
--^^^^^^^^^^^^^^^^^^^^^^]]
if EnterDebugMode then
	print('Type "cont" and press enter to continue executing the rest of the program.')
	debug.debug()
end
